<template>
  <form @submit="onSubmit">
    <div class="header-group">
      <div class="header-group__right">
        <ImageUploadField class="thumbnail" v-model="thumbnail" id="thumbnail" title="تصویر محصول" @input="onThumbnailChange"/>
      </div>
      <div class="header-group__left">
        <TextField label="عنوان" dark v-model="title" id="product-title-field" class="field" :error="titleError"/>
        <TextField label="توضیحات کوتاه" dark v-model="shortDescription" id="product-short-description-field" class="field" :error="shortDescriptionError"/>
        <Select v-model="selectedCategory" label="دسته بندی" id="product-category-field" dark :options="categories" class="field" />
      </div>
    </div>
     <div class="quill-editor" 
         :content="description"
         @change="onEditorChange($event)"
         v-quill:myQuillEditor="editorOption">
    </div>
    <GalleryForm class="field" v-model="pictures" @change="onGalleryChange" />
    <TextField label="قیمت (تومان)" dark v-model="price" id="product-price-field" class="field" :error="priceError" />
    <TextField label="درصد تخفیف" dark v-model="off" id="product-off-field" class="field" :error="offError" />
    <TextField label="تعداد کالا" dark v-model="quantity" id="product-quantity-field" class="field" :error="quantityError" />
    <Button size="lg" type="contained" color="primary" class="button" :disabled="disabled" @click.native="onSubmit">{{ ButtonLabel }}</Button>
  </form>
</template>

<script>
import Button from "@/components/base/Button";
import TextField from "@/components/base/TextField";
import GalleryForm from "@/components/dashboard/GalleryForm";
import Select from "@/components/base/Select";
import UploadIcon from "@/assets/svgs/upload.svg";
import AddImageIcon from "@/assets/svgs/image.svg";
import ImageUploadField from "@/components/dashboard/ImageUploadField";


export default {
  name: "CreateCategoryForm",
  components: {
    Button,
    TextField,
    Select,
    AddImageIcon,
    GalleryForm,
    UploadIcon,
    ImageUploadField
  },
  data() {
    return {
      baseUrl: process.env.baseUrl,
      oldTitle: this.product ? this.product.title : '',
      title: this.product ? this.product.title : '',
      oldShortDescription: this.product ? this.product.shortDescription : '',
      shortDescription: this.product ? this.product.shortDescription : '',
      oldPrice: this.product ? String(this.product.price) : '',
      price: this.product ? String(this.product.price) : '',
      oldOff: this.product ? String(this.product.off) : '',
      off: this.product ? String(this.product.off) : '',
      oldQuantity: this.product ? String(this.product.quantity) : '',
      quantity: this.product ? String(this.product.quantity) : '',
      oldDescription: this.product ? this.product.description : '',
      description: this.product ? this.product.description : '',
      selectedCategory: this.product ? this.product.category : {},
      thumbnail: this.product ? `${process.env.baseUrl}/${this.product.thumbnail}` : '',
      pictures: this.product ? this.product.pictures : [],
      hasPicturesChanged: false,
      hasThumbnailChanged: false,
      oldCategory: this.product ? this.product.category : undefined,
      editorOption: {
        placeholder: 'توضیحات محصول ...',
        modules: {
          toolbar: [
            ['bold', 'italic', 'underline', 'strike'],      
            ['blockquote'],
            [{ 'header': [2, 3, false] }],
          ]
        }
      }
    }
  },
  props: {
    product: {
      type: Object,
      default: null
    },
    categories: {
      type: Array,
      required: true
    }
  },
  methods: {
    onSubmit(e) {
      e.preventDefault();
      if (this.product) {
        this.update();
      } else {
        this.create();
      }
    },
    update() {
      if (this.canUpdate) {
        this.$store.dispatch('shop/updateProduct', {
          token: this.$store.getters['auth/getToken'],
          data: this.updateData,
          id: this.$route.params.id
        }).then(response => {
          console.log(response.data.data)
          if (response.status === 200) {
            this.$store.dispatch('notifications/push', {
              message: "محصول با موفقیت بروزرسانی شد.",
              light: true,
              type: "success",
              timeout: 3000
            });
            this.$router.push('/dashboard/admin/products');
            // this.$emit('update');
          } else {
            this.$store.dispatch('notifications/push', {
              message: "ورودی های شما نا معتبر می باشد.",
              light: true,
              type: "warning",
              timeout: 3000
            });
          }
        }).catch(error => {
          this.$store.dispatch('notifications/push', {
            message: "خطا در اتصال به سرور! لطفا دقایقی دیگر دوباره امتحان کنید.",
            type: "error",
            timeout: 3500
          });
        });
      } else {
        this.$store.dispatch('notifications/push', {
          message: "ورودی های خود را کنترل کنید.",
          light: true,
          type: "warning",
          timeout: 3000
        });
      }
    },
    create() {
      if (this.canCreate) {
        const data = {
          token: this.$store.getters['auth/getToken'],
          data: this.craeteData
        };
        this.$store.dispatch('shop/createProduct', data).then(response => {
          if (response.status === 201) {
            this.$store.dispatch('notifications/push', {
              message: "محصول با موفقیت اضافه شد.",
              light: true,
              type: "success",
              timeout: 3000
            });
            this.$emit('create');
          } else {
            this.$store.dispatch('notifications/push', {
              message: "ورودی های شما نا معتبر می باشد.",
              light: true,
              type: "warning",
              timeout: 3000
            });
          }
        }).catch(error => {
          this.$store.dispatch('notifications/push', {
            message: "خطا در اتصال به سرور! لطفا دقایقی دیگر دوباره امتحان کنید.",
            type: "error",
            timeout: 3500
          });
        });
      } else {
        this.$store.dispatch('notifications/push', {
          message: "ورودی های خود را کنترل کنید.",
          light: true,
          type: "warning",
          timeout: 3000
        });
      }
    },
    onThumbnailChange(image, change) {
      this.hasThumbnailChanged = change ? true : false;
    },
    onEditorChange({ editor, html, text }) {
      this.description = html;
    },
    onGalleryChange() {
      this.hasPicturesChanged = true;
    }
  },
  computed: {
    category() {
      return this.categories.find(cur => cur.id === this.selectedCategory.id);
    },
    hasInfoChanged() {
      return this.title !== this.oldTitle || 
        this.shortDescription !== this.oldShortDescription ||
        this.price !== this.oldPrice ||
        this.off !== this.oldOff ||
        this.quantity !== this.oldQuantity ||
        this.hasCategoryChanged ||
        this.description !== this.oldDescription ? true : false;
    },
    hasCategoryChanged() {
      if (!this.oldCategory) {
        if (this.category) {
          return true;
        }
        return false;
      } else {
        if (!this.category) {
          return true;
        } else if (this.category.id !== this.oldCategory.id) {
          return true;
        } else {
          return false;
        }
      }
    },
    hasChanged() {
      return this.hasPicturesChanged || this.hasInfoChanged || this.hasThumbnailChanged ? true : false;
    },
    updateData() {
      let data = {};
      if (this.hasPicturesChanged) {
        data.pictures = this.pictures;
      }
      if (this.hasThumbnailChanged) {
        data.logo = this.thumbnail;
      }
      data.title = this.title;
      data.short_description = this.shortDescription;
      data.category_id = this.category.id;
      data.description = this.description;
      data.price = Number(this.price);
      data.off = this.off ? Number(this.off) : 0;
      data.quantity = Number(this.quantity);
      return data;
    },
    craeteData() {
      return {
        title: this.title,
        short_description: this.shortDescription,
        description: this.description,
        logo: this.thumbnail,
        price: Number(this.price),
        pictures: this.pictures,
        quantity: Number(this.quantity),
        category_id: this.category.id,
        off: this.off ? Number(this.off) : 0,
        active: true
      }
    },
    canUpdate() {
      return this.isFormValid && this.isFormFilled && this.hasChanged ? true : false;
    },
    canCreate() {
      return this.isFormFilled && this.isFormValid ? true : false;
    },
    isFormValid() {
      return this.titleError || this.shortDescriptionError || this.priceError || this.offError || this.quantityError ? false : true;
    },
    isFormFilled() {
      return this.title && this.category && this.shortDescription && this.description && this.thumbnail && this.price && this.quantity && this.off ? true : false;
    },
    disabled() {
      if (this.product) {
        return !this.canUpdate;
      } else {
        return this.isFormFilled ? false : true;
      }
    },
    titleError() {
      const regex = /^[آ-ی ء چ]+$/;
      if (!this.title) {
        return "";
      } else if (!regex.test(this.title)) {
        return "فقط از حروف فارسی استفاده کنید!";
      } else {
        return "";
      }
    },
    shortDescriptionError() {
      const regex = /^[آ-ی ء چ؟.!]+$/;
      if (!this.shortDescription) {
        return "";
      } else if (!regex.test(this.shortDescription)) {
        return "فقط از حروف فارسی استفاده کنید!";
      } else {
        return "";
      }
    },
    priceError() {
      const regex = /^\d*$/;
      if (!this.price) {
        return "";
      } else if (!regex.test(this.price)) {
        return "فقط از اعداد استفاده کنید.";
      } else {
        return "";
      }
    },
    offError() {
      const regex = /^([0-9]|[1-9][0-9])$/;
      if (!this.off) {
        return "";
      } else if (!regex.test(this.off)) {
        return "فقط یک عدد بین 0 تا 99";
      } else {
        return "";
      }
    },
    quantityError() {
      const regex = /^[1-9][0-9]*$/;
      if (!this.quantity) {
        return "";
      } else if (!regex.test(this.quantity)) {
        return "فقط یک عدد بزرگ تر یا مساوی صفر";
      } else {
        return "";
      }
    },
    ButtonLabel() {
      return this.product ? "بروزرسانی" : "ثبت";
    }
  }
}
</script>

<style lang="stylus" scoped>
@import "~assets/styles/variables"

.field
  margin-bottom $sm

.quill-editor
  margin-bottom $sm
  min-height 30rem
  max-height 45rem
  overflow auto

.button
  width 100%

.thumbnail 
  width 20.4rem
  height 20.4rem

.header-group
  width 100%
  display flex
  &__left
    flex-grow 1
  &__right
    margin-left $sm
</style>